;--- nuts_bolts.inc ---------------------------------------------------------


read_parameter:
		ld		r16,X+
		cpi		r16,'0'
		brlo	read_parameter_err
		cpi		r16,'9'+1
		brsh	read_parameter_err
		subi	r16,'0'
		sts		(parameter),r16
		sbi		GPIOR0,0					// return(true)
		rjmp	read_parameter_end
read_parameter_err:
		cbi		GPIOR0,0					// return(false)
read_parameter_end:		
		ret

;------------------------------------------------------------------------------------------------------------------------

read_value:
		load_p	Y,(value_ascii)
		ldi		r17,6				// 6 char to be read
read_value_loop:
		ld		r16,X+
		cpi		r16,'0'
		brlo	read_value_err		// char < '0'
		cpi		r16,'9'+1
		brlo	read_value_char		// char >= '0' && char <= '9'
		cpi		r16,'A'
		brlo	read_value_err		// char < 'A'
		cpi		r16,'F'+1
		brsh	read_value_err		// char > 'F'
read_value_char:
		st		Y+,r16
		dec		r17
		brne	read_value_loop
		st		Y,NULL
		ld		r16,X
		tst		r16
		brne	read_value_err		// to many arguments
		sbi		GPIOR0,0			// return(true)
		rjmp	read_value_end
read_value_err:
		cbi		GPIOR0,0			// return(false)
read_value_end:
		ret	

;------------------------------------------------------------------------------------------------------------------------

convert_value:
		push	r17
		load_p	Y,(value)
		load_p	X,(value_ascii)
		ldi		r18,3	
convert_value_loop:
		ld		r17,X+
		ld		r16,X+
		subi	r16,'0'
		subi	r17,'0'
		cpi		r16,9+1				
		brlo	convert_char_hi		// r16 <=9
		subi	r16,7
convert_char_hi:
		cpi		r17,9+1				
		brlo	convert_char		// r17 <=9
		subi	r17,7
convert_char:
		swap	r17
		add		r16,r17
		st		Y+,r16
		dec		r18
		brne	convert_value_loop
		pop		r17
		ret

;------------------------------------------------------------------------------------------------------------------------
convert_to_bin:
		load_p	Y,(buffer)
		ldi		r17,3
		ldi		r19,'0'
		ldi		r20,'1'
convert_to_bin_byte_loop:
		ldi		r18,8
		ld		r16,X+
convert_to_bin_bit_loop:
		lsl		r16
		brcs	convert_to_bin_bit_hi
convert_to_bin_bit_lo:
		st		Y+,r19
		rjmp	convert_to_bin_bit
convert_to_bin_bit_hi:
		st		Y+,r20
convert_to_bin_bit:
		dec		r18
		brne	convert_to_bin_bit_loop
		dec		r17
		brne	convert_to_bin_byte_loop
		st		Y,NULL
		ret


;------------------------------------------------------------------------------------------------------------------------
convert_to_bin19:
		load_p	Y,(buffer)
		ldi		r19,'0'
		ldi		r20,'1'
		ld		r18,X+
		ld		r17,X+
		ld		r16,X+
		ldi		r21,20
convert_to_bin19_loopb:
		lsl		r16
		rol		r17
		rol		r18
		brcs	convert_to_bin19_bit_hi
convert_to_bin19_bit_lo:
		st		Y+,r19
		rjmp	convert_to_bin19_bit
convert_to_bin19_bit_hi:
		st		Y+,r20
convert_to_bin19_bit:
		dec		r21
		brne	convert_to_bin19_loopb
		st		Y,NULL
		ret
