;--- sw_smarten.inc ---------------------------------------------------------

// controls STEP pulses by PCINT to increase motor current
// readout TMC status to detect standstill/overtemp prewarning to decrease motor current

init_smarten:
// init TIMER0 to a cycle tick of 30s
		ldi		r16, (1<<WGM01)|(0<<WGM00)
		out		TCCR0A,r16
		ldi		r16,(TICK_VAL)
		out		OCR0A,r16
		ldi		r16,(1<<OCIE0A)
		sts		TIMSK0,r16
		ldi		r16, (0<<WGM02)|(0<<CS02)|(1<<CS01)|(0<<CS00)
		out		TCCR0B,r16
// init TIMER1 to a cycle ticks of 125ms & 250ms
		ldi		r16,byte2(Blink_VAL)
		sts		OCR1AH,r16
		ldi		r16,byte1(Blink_VAL)
		sts		OCR1AL,r16
		ldi		r16, (0<<WGM11)|(0<<WGM10)
		sts		TCCR1A,r16
		ldi		r16, (0<<WGM13)|(1<<WGM12)|(1<<CS12)|(0<<CS11)|(1<<CS10)
		sts		TCCR1B,r16
		ldi		r16,(1<<OCIE1A)
		sts		TIMSK1,r16
		ldi		r16,4
		mov		BLINK_CNT,r16
		ret


TIMER0_COMPA:
		sbi		GPIOR0,TICK_30us
		reti

TIMER1_COMPA:
		in		iSREG,SREG
		sbic	GPIOR0,BLINK_fast
		rjmp	tim1_tongle_blink_fast_off
		sbi		GPIOR0,BLINK_fast
		rjmp	tim1_tongle_blink_fast_end
tim1_tongle_blink_fast_off:
		cbi		GPIOR0,BLINK_fast
tim1_tongle_blink_fast_end:
		tst		BLINK_CNT
		brne	tim1_tongle_blink_slow_end
		ldi		itemp_A,4
		mov		BLINK_CNT,itemp_A
		sbic	GPIOR0,BLINK_slow
		rjmp	tim1_tongle_blink_slow_off
		sbi		GPIOR0,BLINK_slow
		rjmp	tim1_tongle_blink_slow_end
tim1_tongle_blink_slow_off:
		cbi		GPIOR0,BLINK_slow
tim1_tongle_blink_slow_end:
		dec		BLINK_CNT
		sbic	GPIOR0,ERROR
		rjmp	timer1_compa_blk_fast
;		cbi		EN_PORT,EN_PIN
		sbis	GPIOR0,WARNING
		rjmp	timer1_compa_ld2_on
timer1_compa_blk_slow:
		sbic	GPIOR0,BLINK_slow
		cbi		LD2_PORT,LD2_PIN
		sbis	GPIOR0,BLINK_slow
		sbi		LD2_PORT,LD2_PIN
		rjmp	timer1_compa_end
timer1_compa_blk_fast:
;		sbi		EN_PORT,EN_PIN
		sbic	GPIOR0,BLINK_fast
		cbi		LD2_PORT,LD2_PIN
		sbis	GPIOR0,BLINK_fast
		sbi		LD2_PORT,LD2_PIN
		rjmp	timer1_compa_end
timer1_compa_ld2_on:
		cbi		LD2_PORT,LD2_PIN
timer1_compa_end:
		out		SREG,iSREG	
		reti


PC_INT1:
		in		iSREG,SREG
		sbi		GPIOR0,ERROR
		out		SREG,iSREG
		reti
