;--- Settings ---------------------------------------------------------

watchdog_on:
; Turn off global interrupt
		cli
; Reset Watchdog Timer
		wdr
; Start timed sequence
		lds 		r16,WDTCSR
		ori 		r16,(1<<WDCE) | (1<<WDE)
		sts 		WDTCSR,r16
; -- Got four cycles to set the new values from here -
; Set new prescaler(time-out) value = 2K cycles (~ 16 ms )
		ldi 		r16,(1<<WDE) | (0<<WDP3) | (0<<WDP2) | (0<<WDP1) | (0<<WDP0)
		sts 		WDTCSR,r16
; -- Finished setting new values, used 2 cycles -
; Turn on global interrupt
		sei
		ret


watchdog_off:
; Turn off global interrupt
		cli
; Reset Watchdog Timer
		wdr
; Clear WDRF in MCUSR
		in 			r16,MCUSR
		andi 		r16,(0xff & (0<<WDRF))
		out 		MCUSR,r16
; Write logical one to WDCE and WDE
; Keep old prescaler setting to prevent unintentional time-out
		lds 		r16,WDTCSR
		ori 		r16,(1<<WDCE) | (1<<WDE)
		sts 		WDTCSR,r16
; Turn off WDT
		ldi 		r16,(0<<WDE)
		sts 		WDTCSR,r16
; Turn on global interrupt
;		sei
		ret
